## kexec-tools 2.0.29

=== util/Makefile ===
BIN_TO_HEX:= bin/bin-to-hex

$(BIN_TO_HEX): $(srcdir)/util/bin-to-hex.c
	@$(MKDIR) -p $(@D)
	$(LINK.o) $(CFLAGS) -o $@ $^

$(BIN_TO_HEX): CC=$(BUILD_CC)
$(BIN_TO_HEX): CFLAGS=$(BUILD_CFLAGS)
$(BIN_TO_HEX): LDFLAGS=

dist += util/Makefile util/bin-to-hex.c
clean += util/bin-to-hex.o $(BIN_TO_HEX)

=== kexec/arch/ppc/Makefile ===
#
# kexec ppc (linux booting linux)
#
include $(srcdir)/kexec/libfdt/Makefile.libfdt

ppc_KEXEC_SRCS =  kexec/arch/ppc/kexec-ppc.c
ppc_KEXEC_SRCS += kexec/arch/ppc/kexec-elf-ppc.c
ppc_KEXEC_SRCS += kexec/arch/ppc/kexec-elf-rel-ppc.c
ppc_KEXEC_SRCS += kexec/arch/ppc/kexec-dol-ppc.c
ppc_KEXEC_SRCS += kexec/arch/ppc/kexec-uImage-ppc.c
ppc_KEXEC_SRCS += kexec/arch/ppc/ppc-setup-simple.S
ppc_KEXEC_SRCS += kexec/arch/ppc/ppc-setup-dol.S
ppc_KEXEC_SRCS += kexec/arch/ppc/fixup_dtb.c
ppc_KEXEC_SRCS += kexec/arch/ppc/fs2dt.c
ppc_KEXEC_SRCS += kexec/arch/ppc/crashdump-powerpc.c

ppc_UIMAGE = kexec/kexec-uImage.c

ppc_libfdt_SRCS = kexec/arch/ppc/libfdt-wrapper.c
libfdt_SRCS += $(LIBFDT_SRCS:%=kexec/libfdt/%)
ppc_ARCH_REUSE_INITRD =

ppc_CPPFLAGS = -I$(srcdir)/kexec/libfdt

ppc_KEXEC_SRCS += $(libfdt_SRCS) $(ppc_libfdt_SRCS)

ppc_ASFLAGS = -Wa,--noexecstack

dist += kexec/arch/ppc/Makefile $(ppc_KEXEC_SRCS)			\
	kexec/arch/ppc/crashdump-powerpc.h kexec/arch/ppc/fixup_dtb.h	\
	kexec/arch/ppc/kexec-ppc.h kexec/arch/ppc/ops.h			\
	kexec/arch/ppc/ppc_asm.h					\
	kexec/arch/ppc/include/page.h kexec/arch/ppc/include/types.h	\
	kexec/arch/ppc/include/arch/options.h

=== purgatory/arch/s390/Makefile ===
#
# Purgatory s390
#

s390_PURGATORY_SRCS += purgatory/arch/s390/console-s390.c
s390_PURGATORY_SRCS += purgatory/arch/s390/setup-s390.S
s390_PURGATORY_SRCS += purgatory/arch/s390/purgatory-s390.c

dist += purgatory/arch/s390/Makefile $(s390_PURGATORY_SRCS)

=== debian/changelog ===
kexec-tools (1:2.0.29-2) unstable; urgency=medium

  * Remove armhf from build-depends for libxen-dev (Closes: #1090991)

 -- Khalid Aziz <khalid@debian.org>  Mon, 30 Dec 2024 18:40:42 +0000

kexec-tools (1:2.0.29-1) unstable; urgency=medium

  * New upstream release (Closes: #1064379)
  * Fix for FTBFS on loong64 is in upstream now (Closes: #1068061)
  * Updated debian patch static_binary_warning.patch with the patch in
    bug 1010182 (Closes: #1010182)
  * Removed patch 328de8e00e298f00d7ba6b25dc3950147e9642e6.patch since
    it is in upstream now
  * Added missing newline to the error message (Closes: #1061537)

 -- Khalid Aziz <khalid@debian.org>  Mon, 29 Jul 2024 13:36:10 -0600

kexec-tools (1:2.0.27-1.3) unstable; urgency=medium
  * Non-maintainer upload.
  * Conflict with DEP17-unmitigated versions of molly-guard, bfh-container,
    progress-linux-container. (Closes: #1074086)

 -- Chris Hofstaedtler <zeha@debian.org>  Sun, 23 Jun 2024 12:26:20 +0200

kexec-tools (1:2.0.27-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Install programs into canonical locations in /usr. (DEP17 M2)
    (Closes: #1073031)

 -- Chris Hofstaedtler <zeha@debian.org>  Wed, 12 Jun 2024 00:36:59 +0200

kexec-tools (1:2.0.27-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Apply upstream patch to fix build with binutils 2.41 (Closes: #1058433)

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 27 Apr 2024 14:49:56 +0200

=== debian/control ===
Source: kexec-tools
Section: admin
Homepage: https://git.kernel.org/pub/scm/utils/kernel/kexec/kexec-tools.git/
Priority: optional
Maintainer: Khalid Aziz <khalid@debian.org>
Build-Depends: debhelper (>= 10.0.0),  debhelper-compat (= 13), gnu-efi (>=3.0a-4)[ia64], libz-dev[arm64 ia64], po-debconf, libxen-dev[amd64 arm64]
Standards-Version: 4.5.1.0
Rules-Requires-Root: no

Package: kexec-tools
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}, debconf, dpkg (>= 1.15.7.2)
Conflicts: molly-guard (<< 0.8.4~), bfh-container (<< 20211009-22~), progress-linux-container (<< 20221002-11~)
Description: tools to support fast kexec reboots
 This package provides tools to load a kernel into memory and then
 "reboot" directly into that kernel using the kexec system call,
 bypassing the normal boot process.

Package: kexec-tools-udeb
Section: debian-installer
Architecture: linux-any
XC-Package-Type: udeb
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: tools to support fast kexec reboots (udeb)

## kexec-tools 2.0.31

=== purgatory/Makefile ===
#
# Purgatory (an uncomfortable intermediate state)
#            In this case the code that runs between kernels
#

# There is probably a cleaner way to do this but for now this
# should keep us from accidentially include unsafe library functions
# or headers.

PURGATORY = purgatory/purgatory.ro
PURGATORY_SRCS =
PURGATORY_SRCS += purgatory/purgatory.c
PURGATORY_SRCS += purgatory/printf.c
PURGATORY_SRCS += purgatory/string.c
PURGATORY_MAP = purgatory/purgatory.map

dist += purgatory/Makefile $(PURGATORY_SRCS)				\
	purgatory/include/purgatory.h purgatory/include/string.h

include $(srcdir)/purgatory/arch/alpha/Makefile
include $(srcdir)/purgatory/arch/arm/Makefile
include $(srcdir)/purgatory/arch/arm64/Makefile
include $(srcdir)/purgatory/arch/i386/Makefile
include $(srcdir)/purgatory/arch/ia64/Makefile
include $(srcdir)/purgatory/arch/mips/Makefile
include $(srcdir)/purgatory/arch/ppc/Makefile
include $(srcdir)/purgatory/arch/ppc64/Makefile
include $(srcdir)/purgatory/arch/s390/Makefile
include $(srcdir)/purgatory/arch/sh/Makefile
include $(srcdir)/purgatory/arch/x86_64/Makefile
include $(srcdir)/purgatory/arch/loongarch/Makefile

PURGATORY_SRCS+=$($(ARCH)_PURGATORY_SRCS)

PURGATORY_OBJS = $(call objify, $(PURGATORY_SRCS)) purgatory/sha256.o
PURGATORY_DEPS = $(call depify, $(PURGATORY_OBJS))

clean += $(PURGATORY_OBJS) $(PURGATORY_DEPS) $(PURGATORY) $(PURGATORY_MAP) $(PURGATORY).sym

-include $(PURGATORY_DEPS)

purgatory/sha256.o: CFLAGS += -O2 $($(ARCH)_PURGATORY_SHA256_CFLAGS)

purgatory/sha256.o: $(srcdir)/util_lib/sha256.c
	mkdir -p $(@D)
	$(COMPILE.c) -o $@ $^

$(PURGATORY): CC=$(TARGET_CC)
$(PURGATORY): CFLAGS=$(PURGATORY_EXTRA_CFLAGS) \
		      $($(ARCH)_PURGATORY_EXTRA_CFLAGS) \
		      -Os -fno-builtin -ffreestanding \
		      -fno-zero-initialized-in-bss \
		      -fno-PIC -fno-PIE -fno-stack-protector -fno-tree-vectorize

$(PURGATORY): CPPFLAGS=$($(ARCH)_PURGATORY_EXTRA_CFLAGS) \
			-I$(srcdir)/purgatory/include \
			-I$(srcdir)/purgatory/arch/$(ARCH)/include \
			-I$(srcdir)/util_lib/include \
			-I$(srcdir)/include \
			-Iinclude \
			-I$(shell $(CC) -print-file-name=include)
$(PURGATORY): LDFLAGS=$($(ARCH)_PURGATORY_EXTRA_CFLAGS)\
			-Wl,--no-undefined -nostartfiles -nostdlib \
			-nodefaultlibs -e purgatory_start -r \
			-Wl,-Map=$(PURGATORY_MAP)

$(PURGATORY): $(PURGATORY_OBJS)
	$(MKDIR) -p $(@D)
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@.sym $^
#	$(LD) $(LDFLAGS) $(EXTRA_LDFLAGS) --no-undefined -e purgatory_start -r -o $@ $(PURGATORY_OBJS) $(UTIL_LIB)
	$(STRIP) --strip-debug -o $@ $@.sym

echo::
	@echo "PURGATORY_SRCS $(PURGATORY_SRCS)"
	@echo "PURGATORY_DEPS $(PURGATORY_DEPS)"
	@echo "PURGATORY_OBJS $(PURGATORY_OBJS)"

=== kexec/arch/alpha/Makefile ===
alpha_KEXEC_SRCS=
dist += kexec/arch/alpha/Makefile kexec/arch/alpha/include/arch/options.h
        $(alpha_KEXEC_SRCS)

=== kexec/arch/loongarch/Makefile ===
#
# kexec loongarch (linux booting linux)
#
loongarch_KEXEC_SRCS =  kexec/arch/loongarch/kexec-loongarch.c
loongarch_KEXEC_SRCS += kexec/arch/loongarch/kexec-elf-loongarch.c
loongarch_KEXEC_SRCS += kexec/arch/loongarch/kexec-pei-loongarch.c
loongarch_KEXEC_SRCS += kexec/arch/loongarch/kexec-elf-rel-loongarch.c
loongarch_KEXEC_SRCS += kexec/arch/loongarch/crashdump-loongarch.c
loongarch_KEXEC_SRCS += kexec/arch/loongarch/kexec-pez-loongarch.c

loongarch_MEM_REGIONS = kexec/mem_regions.c

loongarch_CPPFLAGS += -I $(srcdir)/kexec/

loongarch_ADD_BUFFER =
loongarch_ADD_SEGMENT =
loongarch_VIRT_TO_PHYS =

dist += kexec/arch/loongarch/Makefile $(loongarch_KEXEC_SRCS)			\
	kexec/arch/loongarch/kexec-loongarch.h					\
	kexec/arch/loongarch/image-header.h					\
	kexec/arch/loongarch/iomem.h						\
	kexec/arch/loongarch/crashdump-loongarch.h				\
	kexec/arch/loongarch/include/arch/options.h

=== purgatory/arch/arm64/Makefile ===

arm64_PURGATORY_EXTRA_CFLAGS = \
	-mcmodel=large \
	-fno-PIC \
	-fno-stack-protector \
	-fno-asynchronous-unwind-tables \
	-Wundef \
	-Werror-implicit-function-declaration \
	-Wdeclaration-after-statement \
	-Werror=implicit-int \
	-Werror=strict-prototypes

arm64_PURGATORY_SRCS += \
	purgatory/arch/arm64/entry.S \
	purgatory/arch/arm64/purgatory-arm64.c

dist += \
	$(arm64_PURGATORY_SRCS) \
	purgatory/arch/arm64/Makefile

=== purgatory/arch/i386/Makefile ===
#
# Purgatory i386
#

i386_PURGATORY_SRCS =  purgatory/arch/i386/entry32-16.S
i386_PURGATORY_SRCS += purgatory/arch/i386/entry32-16-debug.S
i386_PURGATORY_SRCS += purgatory/arch/i386/entry32.S
i386_PURGATORY_SRCS += purgatory/arch/i386/setup-x86.S
i386_PURGATORY_SRCS += purgatory/arch/i386/stack.S
i386_PURGATORY_SRCS += purgatory/arch/i386/compat_x86_64.S
i386_PURGATORY_SRCS += purgatory/arch/i386/purgatory-x86.c
i386_PURGATORY_SRCS += purgatory/arch/i386/console-x86.c
i386_PURGATORY_SRCS += purgatory/arch/i386/vga.c
i386_PURGATORY_SRCS += purgatory/arch/i386/pic.c
i386_PURGATORY_SRCS += purgatory/arch/i386/crashdump_backup.c

dist += purgatory/arch/i386/Makefile $(i386_PURGATORY_SRCS)	\
	purgatory/arch/i386/purgatory-x86.h			\
	purgatory/arch/i386/include/arch/io.h			\
	purgatory/arch/i386/include/arch/debug.h

=== purgatory/arch/sh/Makefile ===
#
# Purgatory sh
#

sh_PURGATORY_SRCS =

dist += purgatory/arch/sh/Makefile $(sh_PURGATORY_SRCS)

=== purgatory/arch/x86_64/Makefile ===
#
# Purgatory x86_64
#

x86_64_PURGATORY_SRCS_native = purgatory/arch/x86_64/entry64-32.S
x86_64_PURGATORY_SRCS_native += purgatory/arch/x86_64/entry64.S
x86_64_PURGATORY_SRCS_native += purgatory/arch/x86_64/setup-x86_64.S
x86_64_PURGATORY_SRCS_native += purgatory/arch/x86_64/stack.S
x86_64_PURGATORY_SRCS_native += purgatory/arch/x86_64/purgatory-x86_64.c

x86_64_PURGATORY_SRCS += $(x86_64_PURGATORY_SRCS_native)

dist += purgatory/arch/x86_64/Makefile $(x86_64_PURGATORY_SRCS_native) 	\
	purgatory/arch/x86_64/include/arch/io.h				\
	purgatory/arch/x86_64/include/arch/debug.h			\
	purgatory/arch/x86_64/purgatory-x86_64.h

# Don't add sources in i386/ to dist, as i386/Makefile adds them
x86_64_PURGATORY_SRCS += purgatory/arch/i386/entry32-16.S
x86_64_PURGATORY_SRCS += purgatory/arch/i386/entry32-16-debug.S
x86_64_PURGATORY_SRCS += purgatory/arch/i386/crashdump_backup.c
x86_64_PURGATORY_SRCS += purgatory/arch/i386/console-x86.c
x86_64_PURGATORY_SRCS += purgatory/arch/i386/vga.c
x86_64_PURGATORY_SRCS += purgatory/arch/i386/pic.c

ifneq ($(SUBARCH),x32)
x86_64_PURGATORY_EXTRA_CFLAGS = -mcmodel=large
endif

=== debian/changelog ===
kexec-tools (1:2.0.31-1ubuntu2) questing; urgency=medium

  * control, rules: Drop xen again.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 11 Sep 2025 09:57:01 +0300

kexec-tools (1:2.0.31-1ubuntu1) questing; urgency=medium

  * New upstream release (LP: #2122318). Remaining changes:
    - d/p/379d8f3ef3219bd400c7893d0a262b079c1de408.patch: riscv64 support
  * Add libzstd-dev build dependency for EFI_ZBOOT

 -- Tobias Heider <tobias.heider@canonical.com>  Wed, 10 Sep 2025 15:56:41 +0200

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,9 @@
 Section: admin
 Homepage: https://git.kernel.org/pub/scm/utils/kernel/kexec/kexec-tools.git/
 Priority: optional
-Maintainer: Khalid Aziz <khalid@debian.org>
-Build-Depends: debhelper (>= 10.0.0),  debhelper-compat (= 13), gnu-efi (>=3.0a-4)[ia64], libz-dev[arm64 ia64], po-debconf, libxen-dev[amd64 arm64]
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Khalid Aziz <khalid@debian.org>
+Build-Depends: debhelper (>= 10.0.0),  debhelper-compat (= 13), gnu-efi (>=3.0a-4)[ia64], libz-dev[arm64 ia64], po-debconf, libzstd-dev
 Standards-Version: 4.5.1.0
 Rules-Requires-Root: no

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

BUILD_DATE = $(shell dpkg-parsechangelog -S Date | LC_ALL=C date -u +'%d %B %Y' -f -)
export BUILD_DATE

ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
	NJOBS := -j $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

#export DH_VERBOSE = 1
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

CFLAGS = -Wall -g

%:
	dh $@

configure: configure-stamp
configure-stamp:
	dh_testdir
	dh_update_autotools_config
	dh_autoreconf
	CPPFLAGS="$(shell dpkg-buildflags --get CPPFLAGS)" CFLAGS="$(shell dpkg-buildflags --get CFLAGS)" LDFLAGS="$(shell dpkg-buildflags --get LDFLAGS)" dh_auto_configure -- --prefix=/usr --exec-prefix=/usr --sbindir=/usr/sbin --mandir=/usr/share/man --datadir=/usr/share --without-xen
	touch configure-stamp

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp

build-stamp: configure-stamp
	dh_testdir
	$(MAKE) $(NJOBS)
	touch build-stamp

clean: configure-stamp
	dh_testdir
	dh_testroot
	rm -f configure-stamp build-stamp
	rm -fr tmp-source

	# Add here commands to clean up after the build process.
	$(MAKE) dist-clean

	dh_autoreconf_clean
	dh_clean
	debconf-updatepo

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	$(MAKE) install DESTDIR=$(CURDIR)/debian/kexec-tools
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	[ ! -f $(CURDIR)/debian/kexec-tools/usr/lib/kexec-tools-testing/kexec_test.static ] || strip $(CURDIR)/debian/kexec-tools/usr/lib/kexec-tools-testing/kexec_test.static
endif

	install -D -m 0755 debian/kexec-tools/usr/sbin/kexec debian/kexec-tools-udeb/usr/sbin/kexec

binary-indep: build install

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installdocs
	dh_installdebconf
	dh_installexamples
	dh_installsystemd
	dh_lintian
	dh_install
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build build-arch clean binary-indep binary-arch binary install configure

## kexec-tools 2.0.32

=== kexec/Makefile ===
#
# kexec (linux booting linux)
#
PURGATORY_HEX_C = kexec/purgatory.c

$(PURGATORY_HEX_C): $(PURGATORY) $(BIN_TO_HEX)
	$(MKDIR) -p $(@D)
	$(BIN_TO_HEX) purgatory < $(PURGATORY) > $@

KEXEC_SRCS = $(KEXEC_SRCS_base)
KEXEC_GENERATED_SRCS =

KEXEC_SRCS_base += kexec/kexec.c
KEXEC_SRCS_base += kexec/ifdown.c
KEXEC_SRCS_base += kexec/kexec-elf.c
KEXEC_SRCS_base += kexec/kexec-elf-exec.c
KEXEC_SRCS_base += kexec/kexec-elf-core.c
KEXEC_SRCS_base += kexec/kexec-elf-rel.c
KEXEC_SRCS_base += kexec/kexec-elf-boot.c
KEXEC_SRCS_base += kexec/kexec-pe-zboot.c
KEXEC_SRCS_base += kexec/kexec-uki.c
KEXEC_SRCS_base += kexec/kexec-iomem.c
KEXEC_SRCS_base += kexec/firmware_memmap.c
KEXEC_SRCS_base += kexec/crashdump.c
KEXEC_SRCS_base += kexec/crashdump-xen.c
KEXEC_SRCS_base += kexec/phys_arch.c
KEXEC_SRCS_base += kexec/lzma.c
KEXEC_SRCS_base += kexec/zlib.c
KEXEC_SRCS_base += kexec/zstd.c
KEXEC_SRCS_base += kexec/kexec-xen.c
KEXEC_SRCS_base += kexec/symbols.c

KEXEC_GENERATED_SRCS += $(PURGATORY_HEX_C)

dist += kexec/Makefile						\
	$(KEXEC_SRCS_base) kexec/crashdump-elf.c		\
	kexec/crashdump.h kexec/firmware_memmap.h		\
	kexec/kexec-elf-boot.h					\
	kexec/kexec-elf.h kexec/kexec-sha256.h			\
	kexec/kexec-zlib.h kexec/kexec-lzma.h                   \
	kexec/kexec-zstd.h                                      \
	kexec/kexec-xen.h 					\
	kexec/kexec-syscall.h kexec/kexec.h kexec/kexec.8

dist				+= kexec/proc_iomem.c
$(ARCH)_PROC_IOMEM		=  kexec/proc_iomem.c
KEXEC_SRCS			+= $($(ARCH)_PROC_IOMEM)

dist				+= kexec/virt_to_phys.c
$(ARCH)_VIRT_TO_PHYS		=  kexec/virt_to_phys.c
KEXEC_SRCS			+= $($(ARCH)_VIRT_TO_PHYS)

dist				+= kexec/phys_to_virt.c
$(ARCH)_PHYS_TO_VIRT		=  kexec/phys_to_virt.c
KEXEC_SRCS			+= $($(ARCH)_PHYS_TO_VIRT)

dist				+= kexec/add_segment.c
$(ARCH)_ADD_SEGMENT		=  kexec/add_segment.c
KEXEC_SRCS			+= $($(ARCH)_ADD_SEGMENT)

dist				+= kexec/add_buffer.c
$(ARCH)_ADD_BUFFER		=  kexec/add_buffer.c
KEXEC_SRCS			+= $($(ARCH)_ADD_BUFFER)

dist				+=  kexec/arch_reuse_initrd.c
$(ARCH)_ARCH_REUSE_INITRD	=  kexec/arch_reuse_initrd.c
KEXEC_SRCS			+= $($(ARCH)_ARCH_REUSE_INITRD)

dist				+= kexec/kexec-uImage.c
$(ARCH)_UIMAGE			=
KEXEC_SRCS			+= $($(ARCH)_UIMAGE)

dist				+= kexec/fs2dt.c kexec/fs2dt.h
$(ARCH)_FS2DT			=
KEXEC_SRCS			+= $($(ARCH)_FS2DT)

dist				+= kexec/mem_regions.c kexec/mem_regions.h
$(ARCH)_MEM_REGIONS		=
KEXEC_SRCS			+= $($(ARCH)_MEM_REGIONS)

dist				+= kexec/dt-ops.c kexec/dt-ops.h
$(ARCH)_DT_OPS		=
KEXEC_SRCS			+= $($(ARCH)_DT_OPS)

include $(srcdir)/kexec/arch/alpha/Makefile
include $(srcdir)/kexec/arch/arm/Makefile
include $(srcdir)/kexec/arch/arm64/Makefile
include $(srcdir)/kexec/arch/i386/Makefile
include $(srcdir)/kexec/arch/ia64/Makefile
include $(srcdir)/kexec/arch/m68k/Makefile
include $(srcdir)/kexec/arch/mips/Makefile
include $(srcdir)/kexec/arch/cris/Makefile
include $(srcdir)/kexec/arch/ppc/Makefile
include $(srcdir)/kexec/arch/ppc64/Makefile
include $(srcdir)/kexec/arch/riscv/Makefile
include $(srcdir)/kexec/arch/s390/Makefile
include $(srcdir)/kexec/arch/sh/Makefile
include $(srcdir)/kexec/arch/x86_64/Makefile
include $(srcdir)/kexec/arch/hppa/Makefile
include $(srcdir)/kexec/arch/loongarch/Makefile

KEXEC_SRCS += $($(ARCH)_KEXEC_SRCS)

KEXEC_OBJS = $(call objify, $(KEXEC_SRCS) $(KEXEC_GENERATED_SRCS))
KEXEC_DEPS = $(call depify, $(KEXEC_OBJS))

clean += $(KEXEC_OBJS) $(KEXEC_DEPS) $(KEXEC_GENERATED_SRCS) \
	 $(KEXEC) $(KEXEC_MANPAGE)

KEXEC = $(SBINDIR)/kexec
KEXEC_MANPAGE = $(MANDIR)/man8/kexec.8

-include $(KEXEC_DEPS)

$(KEXEC): $(KEXEC_OBJS) $(UTIL_LIB)
	@$(MKDIR) -p $(@D)
	$(LINK.o) -o $@ $^ $(CFLAGS) $(LIBS)

$(KEXEC): CPPFLAGS+=-I$(srcdir)/kexec/arch/$(ARCH)/include

kexec/fs2dt.o: CPPFLAGS+=$($(ARCH)_FS2DT_INCLUDE)

$(KEXEC_MANPAGE): kexec/kexec.8
	@$(MKDIR) -p     $(MANDIR)/man8
	cp $^ $(KEXEC_MANPAGE)
echo::
	@echo "KEXEC_SRCS $(KEXEC_SRCS)"
	@echo "KEXEC_DEPS $(KEXEC_DEPS)"
	@echo "KEXEC_OBJS $(KEXEC_OBJS)"

=== kexec_test/Makefile ===
#
# kexec_test Debugging payload to be certain the infrastructure works
#
RELOC:=0x10000
KEXEC_TEST_SRCS:= kexec_test/kexec_test16.S kexec_test/kexec_test.S

dist += kexec_test/Makefile $(KEXEC_TEST_SRCS)				\
	kexec_test/x86-setup-legacy-pic.S kexec_test/kexec_test.ld

BUILD_KEXEC_TEST = no
ifeq ($(ARCH),i386)
BUILD_KEXEC_TEST = yes
endif
ifeq ($(ARCH),x86_64)
BUILD_KEXEC_TEST = yes
endif

ifeq ($(BUILD_KEXEC_TEST),yes)

KEXEC_TEST_OBJS = $(call objify, $(KEXEC_TEST_SRCS))
KEXEC_TEST_DEPS = $(call depify, $(KEXEC_TEST_OBJS))

KEXEC_TEST = $(PKGLIBDIR)/kexec_test

clean += $(KEXEC_TEST_OBJS) $(KEXEC_TEST_DEPS) $(KEXEC_TEST)

-include $(KEXEC_TEST_DEPS)

$(KEXEC_TEST): CC=$(TARGET_CC)
$(KEXEC_TEST): CPPFLAGS+=-DRELOC=$(RELOC)
$(KEXEC_TEST): ASFLAGS+=-m32
#$(KEXEC_TEST): LDFLAGS=-m32 -Wl,-e -Wl,_start -Wl,-Ttext -Wl,$(RELOC) \
#		       -nostartfiles
$(KEXEC_TEST): LDFLAGS=-melf_i386 -e _start -T $(srcdir)/kexec_test/kexec_test.ld

$(KEXEC_TEST): $(KEXEC_TEST_OBJS)
	mkdir -p $(@D)
	$(TARGET_LD) $(LDFLAGS) -o $@ $^

endif

=== util_lib/Makefile ===
#
# Utility function library
#
UTIL_LIB_SRCS +=
UTIL_LIB_SRCS += util_lib/compute_ip_checksum.c
UTIL_LIB_SRCS += util_lib/elf_info.c
UTIL_LIB_SRCS += util_lib/sha256.c
UTIL_LIB_OBJS =$(call objify, $(UTIL_LIB_SRCS))
UTIL_LIB_DEPS =$(call depify, $(UTIL_LIB_OBJS))
UTIL_LIB = libutil.a

-include $(UTIL_LIB_DEPS)

dist  += util_lib/Makefile $(UTIL_LIB_SRCS)				\
	util_lib/include/elf_info.h util_lib/include/sha256.h 		\
	util_lib/include/ip_checksum.h
clean += $(UTIL_LIB_OBJS) $(UTIL_LIB_DEPS) $(UTIL_LIB)

$(UTIL_LIB): CPPFLAGS += -I$(srcdir)/util_lib/include

$(UTIL_LIB): $(UTIL_LIB_OBJS)
	@$(MKDIR) -p $(@D)
	$(AR) rs $(UTIL_LIB) $(UTIL_LIB_OBJS)

=== kexec/arch/arm/Makefile ===
#
# kexec arm (linux booting linux)
#
include $(srcdir)/kexec/libfdt/Makefile.libfdt

arm_FS2DT              = kexec/fs2dt.c
arm_FS2DT_INCLUDE      = -include $(srcdir)/kexec/arch/arm/crashdump-arm.h \
                         -include $(srcdir)/kexec/arch/arm/kexec-arm.h

arm_MEM_REGIONS        = kexec/mem_regions.c

arm_KEXEC_SRCS=  kexec/arch/arm/kexec-elf-rel-arm.c
arm_KEXEC_SRCS+= kexec/arch/arm/kexec-zImage-arm.c
arm_KEXEC_SRCS+= kexec/arch/arm/kexec-uImage-arm.c
arm_KEXEC_SRCS+= kexec/arch/arm/kexec-arm.c
arm_KEXEC_SRCS+= kexec/arch/arm/crashdump-arm.c
arm_KEXEC_SRCS+= kexec/fs2dt.c

libfdt_SRCS += $(LIBFDT_SRCS:%=kexec/libfdt/%)

arm_CPPFLAGS = -I$(srcdir)/kexec/libfdt

# We want 64-bit file IO for kdump to work correctly on LPAE systems
arm_CPPFLAGS += -D_FILE_OFFSET_BITS=64

arm_KEXEC_SRCS += $(libfdt_SRCS)

arm_UIMAGE = kexec/kexec-uImage.c
arm_PHYS_TO_VIRT = kexec/arch/arm/phys_to_virt.c

dist += kexec/arch/arm/Makefile $(arm_KEXEC_SRCS) $(arm_PHYS_TO_VIRT)	\
	kexec/arch/arm/iomem.h kexec/arch/arm/phys_to_virt.h \
	kexec/arch/arm/crashdump-arm.h kexec/arch/arm/kexec-arm.h \
	kexec/arch/arm/include/arch/options.h

=== kexec/arch/i386/Makefile ===
#
# kexec i386 (linux booting linux)
#
i386_KEXEC_SRCS =  kexec/arch/i386/kexec-x86.c
i386_KEXEC_SRCS += kexec/arch/i386/kexec-x86-common.c
i386_KEXEC_SRCS += kexec/arch/i386/kexec-elf-x86.c
i386_KEXEC_SRCS += kexec/arch/i386/kexec-elf-rel-x86.c
i386_KEXEC_SRCS += kexec/arch/i386/kexec-bzImage.c
i386_KEXEC_SRCS += kexec/arch/i386/kexec-multiboot-x86.c
i386_KEXEC_SRCS += kexec/arch/i386/kexec-mb2-x86.c
i386_KEXEC_SRCS += kexec/arch/i386/kexec-beoboot-x86.c
i386_KEXEC_SRCS += kexec/arch/i386/kexec-nbi.c
i386_KEXEC_SRCS += kexec/arch/i386/x86-linux-setup.c
i386_KEXEC_SRCS += kexec/arch/i386/crashdump-x86.c

dist += kexec/arch/i386/Makefile $(i386_KEXEC_SRCS)			\
	kexec/arch/i386/crashdump-x86.h					\
	kexec/arch/i386/kexec-x86.h					\
	kexec/arch/i386/x86-linux-setup.h				\
	kexec/arch/i386/include/arch/options.h

=== kexec/arch/riscv/Makefile ===
#
# kexec riscv
#
riscv_KEXEC_SRCS = kexec/arch/riscv/crashdump-riscv.c
riscv_KEXEC_SRCS += kexec/arch/riscv/kexec-elf-riscv.c
riscv_KEXEC_SRCS += kexec/arch/riscv/kexec-image-riscv.c
riscv_KEXEC_SRCS += kexec/arch/riscv/kexec-riscv.c

riscv_DT_OPS += kexec/dt-ops.c

riscv_MEM_REGIONS = kexec/mem_regions.c

riscv_ARCH_REUSE_INITRD =

riscv_CPPFLAGS += -I $(srcdir)/kexec/

dist += $(riscv_KEXEC_SRCS)				\
	kexec/arch/riscv/image-header.h			\
	kexec/arch/riscv/include/arch/options.h		\
	kexec/arch/riscv/iomem.h			\
	kexec/arch/riscv/kexec-riscv.h			\
	kexec/arch/riscv/Makefile

ifdef HAVE_LIBFDT

LIBS += -lfdt

else

include $(srcdir)/kexec/libfdt/Makefile.libfdt

libfdt_SRCS += $(LIBFDT_SRCS:%=kexec/libfdt/%)

riscv_CPPFLAGS += -I$(srcdir)/kexec/libfdt

riscv_KEXEC_SRCS += $(libfdt_SRCS)

endif

=== purgatory/arch/alpha/Makefile ===
#
# Purgatory alpha
#

alpha_PURGATORY_SRCS =

dist += purgatory/arch/alpha/Makefile $(alpha_PURGATORY_SRCS)

=== purgatory/arch/ia64/Makefile ===
#
# Purgatory ia64
#
ia64_PURGATORY_SRCS += purgatory/arch/ia64/entry.S
ia64_PURGATORY_SRCS += purgatory/arch/ia64/purgatory-ia64.c
ia64_PURGATORY_SRCS += purgatory/arch/ia64/console-ia64.c
ia64_PURGATORY_SRCS += purgatory/arch/ia64/vga.c

ia64_PURGATORY_EXTRA_CFLAGS = -ffixed-r28

# sha256.c needs to be compiled without optimization, else
# purgatory fails to execute on ia64.
ia64_PURGATORY_SHA256_CFLAGS = -O0

dist += purgatory/arch/ia64/Makefile $(ia64_PURGATORY_SRCS)	\
	purgatory/arch/ia64/io.h purgatory/arch/ia64/purgatory-ia64.h

=== purgatory/arch/loongarch/Makefile ===
#
# Purgatory loongarch
#

loongarch_PURGATORY_SRCS+= purgatory/arch/loongarch/purgatory-loongarch.c
loongarch_PURGATORY_SRCS+= purgatory/arch/loongarch/console-loongarch.c

dist += purgatory/arch/loongarch/Makefile $(loongarch_PURGATORY_SRCS)		\
	purgatory/arch/loongarch/purgatory-loongarch.h

=== purgatory/arch/ppc/Makefile ===
#
# Purgatory ppc
#

ppc_PURGATORY_SRCS += purgatory/arch/ppc/v2wrap_32.S
ppc_PURGATORY_SRCS += purgatory/arch/ppc/misc.S
ppc_PURGATORY_SRCS += purgatory/arch/ppc/purgatory-ppc.c
ppc_PURGATORY_SRCS += purgatory/arch/ppc/console-ppc.c

ppc_PURGATORY_EXTRA_CFLAGS += -msoft-float

dist += purgatory/arch/ppc/Makefile $(ppc_PURGATORY_SRCS)		\
	purgatory/arch/ppc/purgatory-ppc.h purgatory/arch/ppc/ppc_asm.h

=== purgatory/arch/ppc64/Makefile ===
#
# Purgatory ppc64
#

ppc64_PURGATORY_SRCS += purgatory/arch/ppc64/v2wrap.S
ppc64_PURGATORY_SRCS += purgatory/arch/ppc64/hvCall.S
ppc64_PURGATORY_SRCS += purgatory/arch/ppc64/purgatory-ppc64.c
ppc64_PURGATORY_SRCS += purgatory/arch/ppc64/console-ppc64.c
ppc64_PURGATORY_SRCS += purgatory/arch/ppc64/crashdump_backup.c
ppc64_PURGATORY_SRCS += purgatory/arch/ppc64/misc.S

ppc64_PURGATORY_EXTRA_CFLAGS += -m64 -msoft-float \
				-fno-exceptions
ppc64_PURGATORY_EXTRA_ASFLAGS += -m64
ifeq ($(SUBARCH),BE)
	ppc64_PURGATORY_EXTRA_LDFLAGS += -melf64ppc
	ppc64_PURGATORY_EXTRA_CFLAGS += -mcall-aixdesc
	ppc64_PURGATORY_EXTRA_ASFLAGS += -mcall-aixdesc
else
	ppc64_PURGATORY_EXTRA_LDFLAGS += -melf64lppc
	ppc64_PURGATORY_EXTRA_CFLAGS += -mlittle-endian
	ppc64_PURGATORY_EXTRA_ASFLAGS += -mlittle-endian
endif

dist += purgatory/arch/ppc64/Makefile $(ppc64_PURGATORY_SRCS)		\
	purgatory/arch/ppc64/hvCall.h					\
	purgatory/arch/ppc64/ppc64_asm.h				\
	purgatory/arch/ppc64/purgatory-ppc64.h

=== purgatory/arch/riscv/Makefile ===
#
# Purgatory riscv
#

riscv_PURGATORY_SRCS =

dist += purgatory/arch/riscv/Makefile $(riscv_PURGATORY_SRCS)

=== debian/changelog ===
kexec-tools (1:2.0.32-3devuan1) unstable; urgency=medium

  * Fork for Devuan.
  * Restore LSB initscripts. (Closes: #917)

 -- Mark Hindley <mark@hindley.org.uk>  Thu, 04 Dec 2025 08:50:05 +0000

kexec-tools (1:2.0.32-3) unstable; urgency=medium

  * Pull in two patches from upstream to fix build failure on ppc
    (Closes: #1118575)
  * Add init scripts as examples to use with sysvinit. These scripts
    are not installed and configured upon package installation,
    rather they are provided as examples to install and configure
    manually (Closes: #1111802)

 -- Khalid Aziz <khalid@debian.org>  Thu, 13 Nov 2025 15:39:54 -0700

kexec-tools (1:2.0.32-2) unstable; urgency=medium

  * Fixed an error that allowed wrong build dependency on armhf to be
    introduced

 -- Khalid Aziz <khalid@debian.org>  Tue, 21 Oct 2025 10:17:01 -0600

kexec-tools (1:2.0.32-1) unstable; urgency=medium

  * New upstream release
  * Upstream now includes support for riscv64 (Closes: #1019254)
  * Include updated translation for Catalan (Closes: #1117788)
  * Removed patch to update GPL text in COPYING. Upstream includes
    this patch now.

 -- Khalid Aziz <khalid@debian.org>  Mon, 20 Oct 2025 11:28:31 -0600

kexec-tools (1:2.0.31-1) unstable; urgency=medium

  * New upstream release
  * Updated README.debian with details on kexec-load-kernel script
    (Closes: #1107909)
  * Upstream commit 1614959f2f0d79b5f7fdc57d6aa42da1a0298153 resolved
    the issue with makedumpfile failure (Closes: #1086491)

 -- Khalid Aziz <khalid@debian.org>  Mon, 18 Aug 2025 14:09:14 -0600

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,12 @@
 Section: admin
 Homepage: https://git.kernel.org/pub/scm/utils/kernel/kexec/kexec-tools.git/
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Khalid Aziz <khalid@debian.org>
-Build-Depends: debhelper (>= 10.0.0),  debhelper-compat (= 13), gnu-efi (>=3.0a-4)[ia64], libz-dev[arm64 ia64], po-debconf, libzstd-dev
+Maintainer: Devuan Developers <devuan-dev@lists.dyne.org>
+Uploaders: Mark Hindley <mark@hindley.org.uk>
+Origin: Devuan
+Vcs-Browser: https://git.devuan.org/devuan/kexec-tools
+Vcs-Git: https://git.devuan.org/devuan/kexec-tools.git
+Build-Depends: debhelper (>= 10.0.0),  debhelper-compat (= 13), gnu-efi (>=3.0a-4)[ia64], libz-dev[arm64 ia64], po-debconf, libxen-dev[amd64 arm64], quilt
 Standards-Version: 4.5.1.0
 Rules-Requires-Root: no

=== debian/rules ===
--- 
+++ 
@@ -27,7 +27,7 @@
 	dh_testdir
 	dh_update_autotools_config
 	dh_autoreconf
-	CPPFLAGS="$(shell dpkg-buildflags --get CPPFLAGS)" CFLAGS="$(shell dpkg-buildflags --get CFLAGS)" LDFLAGS="$(shell dpkg-buildflags --get LDFLAGS)" dh_auto_configure -- --prefix=/usr --exec-prefix=/usr --sbindir=/usr/sbin --mandir=/usr/share/man --datadir=/usr/share --without-xen
+	CPPFLAGS="$(shell dpkg-buildflags --get CPPFLAGS)" CFLAGS="$(shell dpkg-buildflags --get CFLAGS)" LDFLAGS="$(shell dpkg-buildflags --get LDFLAGS)" dh_auto_configure -- --prefix=/usr --exec-prefix=/usr --sbindir=/usr/sbin --mandir=/usr/share/man --datadir=/usr/share
 	touch configure-stamp
 
 build: build-arch build-indep
@@ -75,7 +75,8 @@
 	dh_installdocs
 	dh_installdebconf
 	dh_installexamples
-	dh_installsystemd
+	dh_installinit -r --name=kexec
+	dh_installinit -r --name=kexec-load
 	dh_lintian
 	dh_install
 	dh_installman

## kexec-tools 20070330

=== Makefile ===
# Hey Emacs this is a -*- makefile-*-
include Makefile.conf
VERSION=20070330
DATE=30th March 2007
PACKAGE=kexec-tools-testing

pkgdatadir = $(datadir)/$(PACKAGE)
pkglibdir = $(libdir)/$(PACKAGE)
pkgincludedir = $(includedir)/$(PACKAGE)

# You can specify DESTDIR on the command line to do a add
# a prefix to the install so it doesn't really happen
# Useful for building binary packages
DESTDIR =

EXTRA_CPPFLAGS:= -I./include -I./util_lib/include \
	-DVERSION='"$(VERSION)"' -DRELEASE_DATE='"$(DATE)"' \
	-DPACKAGE='"$(PACKAGE)"' $(DEFS) $(EXTRA_CFLAGS)

PREFIX:=$(OBJDIR)/build
SBINDIR=$(PREFIX)/sbin
BINDIR=$(PREFIX)/bin
LIBEXECDIR=$(PREFIX)/libexec
DATADIR=$(PREFIX)/share
SYSCONFDIR=$(PREFIX)/etc
SHAREDSTATEDIR=$(PREFIX)/com
LOCALSTATEDIR=$(PREFIX)/var
LIBDIR=$(PREFIX)/lib
INFODIR=$(PREFIX)/info
MANDIR=$(PREFIX)/man
MAN1DIR=$(MANDIR)/man1
MAN2DIR=$(MANDIR)/man2
MAN3DIR=$(MANDIR)/man3
MAN4DIR=$(MANDIR)/man4
MAN5DIR=$(MANDIR)/man5
MAN6DIR=$(MANDIR)/man6
MAN7DIR=$(MANDIR)/man7
MAN8DIR=$(MANDIR)/man8
INCLUDEDIR=$(PREFIX)/include

PKGDATADIR=$(DATADIR)/$(PACKAGE)
PKGLIBDIR=$(LIBDIR)/$(PACKAGE)
PKGINCLUDEIR=$(INCLUDEDIR)/$(PACKAGE)

MAN_PAGES:= kexec/kexec.8
MAN_PAGES+= kdump/kdump.8
BINARIES_i386:=  $(SBINDIR)/kexec $(PKGLIBDIR)/kexec_test
BINARIES_x86_64:=$(SBINDIR)/kexec $(PKGLIBDIR)/kexec_test
BINARIES:=$(SBINDIR)/kexec $(SBINDIR)/kdump $(BINARIES_$(ARCH)) 

TARGETS:=$(BINARIES) $(MAN_PAGES)

all: $(TARGETS)

# cc-option
# Usage: cflags-y += $(call cc-option, -march=winchip-c6, -march=i586)
cc-option = $(shell if $(CC) $(CFLAGS) $(EXTRA_CFLAGS) $(1) -S -o /dev/null \
	     -xc /dev/null > /dev/null 2>&1; then echo "$(1)"; else \
	     echo "$(2)"; fi ;)

# Utility function library
#
include util_lib/Makefile

#
# Stand alone utilities
#
include util/Makefile

#
# purgatory (code between kernels)
#
include purgatory/Makefile

#
# kexec (linux booting linux)
#
include kexec/Makefile


# kdump (read a crashdump from memory)
#
include kdump/Makefile

#
# kexec_test (test program)
#
ifeq ($(ARCH),i386)
include kexec_test/Makefile
endif
ifeq ($(ARCH),x86_64)
include kexec_test/Makefile
endif

SPEC=$(PACKAGE).spec
GENERATED_SRCS:= ./configure ./$(SPEC)
TARBALL=$(OBJDIR)/$(PACKAGE)-$(VERSION).tar.gz
SRCS:=$(shell $(FIND) \
	./AUTHORS ./COPYING ./News ./TODO \
	./Makefile ./Makefile.conf.in ./configure.ac \
	./kexec-tools.spec.in ./config ./doc \
	./include ./kexec ./purgatory ./kexec_test ./kdump ./util ./util_lib \
	! -path '*CVS*' ! -name '*~' ! -name '.*' \
	-type f -print )
SRCS+=$(GENERATED_SRCS)
PSRCS:=$(patsubst ./%,$(PACKAGE)-$(VERSION)/%,$(SRCS))

Makefile.conf: Makefile.conf.in configure
	/bin/sh ./configure

configure: configure.ac
	autoconf
	$(RM) -rf autom4te.cache

tarball: $(TARBALL)

$(TARBALL): $(SRCS) $(SPEC)
	$(MKDIR) -p $(OBJDIR)
	$(RM) -f $(OBJDIR)/$(PACKAGE)-$(VERSION)
	$(LN) -s .. $(OBJDIR)/$(PACKAGE)-$(VERSION)
	(cd $(OBJDIR); $(TAR) -cf - $(PSRCS) | gzip -9) > $@

rpm: $(TARBALL)
	$(MKDIR) -p $(OBJDIR)/RPM $(OBJDIR)/SRPM $(OBJDIR)/BUILD $(OBJDIR)/SPECS \
		$(OBJDIR)/TMP $(OBJDIR)/SOURCES
	unset MAKEFLAGS MAKELEVEL; \
	$(RPMBUILD) -ta \
		--define '_rpmdir $(OBJDIR)/RPM' \
		--define '_srcrpmdir $(OBJDIR)/SRPM' \
		--define '_builddir $(OBJDIR)/BUILD' \
		--define '_specdir $(OBJDIR)/SPECS' \
		--define '_tmppath $(OBJDIR)/TMP' \
		--define '_sourcedir $(OBJDIR)/SOURCES' \
		$(TARBALL)

$(SPEC): kexec-tools.spec.in Makefile
	$(SED) -e 's,^Version: $$,Version: $(VERSION),' $< > $@

echo::
	@echo ARCH=$(ARCH)
	@echo BINARIES=$(BINARIES)
	@echo TARGETS=$(TARGETS)
	@echo CC=$(CC)
	@echo AR=$(AR)
	@echo LD=$(LD)

clean:
	@$(FIND) $(OBJDIR) ! -name '*.d' -type f | $(XARGS) $(RM) rm -f
	@$(RM) -rf rpm
	@$(RM) -f config.log config.status config.cache
	@$(RM) -f $(TARBALL)

dist-clean: clean
	@$(RM) -rf $(OBJDIR)
	@$(FIND) . -type f -name '*~' -o -name '*.orig' | $(XARGS) $(RM) -f
	@$(RM) -f Makefile.conf

maintainer-clean: dist-clean
	@$(RM) -f $(GENERATED_SRCS)


install: $(TARGETS)
	for file in $(TARGETS) ; do \
		if test `$(DIRNAME) $$file` =     "$(SBINDIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(sbindir)/; \
			$(INSTALL) -m 555  $$file $(DESTDIR)/$(sbindir)/; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(BINDIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(bindir)/; \
			$(INSTALL) -m 555 $$file $(DESTDIR)/$(bindir)/; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(LIBEXECDIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(libexecdir)/; \
			$(INSTALL) -m 555 $$file $(DESTDIR)/$(libexecdir)/; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(DATADIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(datadir)/; \
			$(INSTALL) -m 444 $$file $(DESTDIR)/$(datadir)/; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(SYSCONFDIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(sysconfdir)/; \
			$(INSTALL) -m 444 $$file $(DESTDIR)/$(sysconfdir)/; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(SHAREDSTATEDIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(sharedstatedir)/; \
			$(INSTALL) -m 444 $$file $(DESTDIR)/$(sharedstatedir)/; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(LOCALSTATEDIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(localstatedir)/; \
			$(INSTALL) -m 444 $$file $(DESTDIR)/$(localstatedir)/; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(LIBDIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(libdir)/; \
			$(INSTALL) -m 444 $$file $(DESTDIR)/$(libdir)/; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(INFODIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(infodir)/; \
			$(INSTALL) -m 444 $$file $(DESTDIR)/$(infodir)/; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(MAN1DIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(mandir)/man1; \
			$(INSTALL) -m 444 $$file $(DESTDIR)/$(mandir)/man1; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(MAN2DIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(mandir)/man2; \
			$(INSTALL) -m 444 $$file $(DESTDIR)/$(mandir)/man2; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(MAN3DIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(mandir)/man3/; \
			$(INSTALL) -m 444 $$file $(DESTDIR)/$(mandir)/man3/; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(MAN4DIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(mandir)/man4/; \
			$(INSTALL) -m 444 $$file $(DESTDIR)/$(mandir)/man4/; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(MAN5DIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(mandir)/man5/; \
			$(INSTALL) -m 444 $$file $(DESTDIR)/$(mandir)/man5/; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(MAN6DIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(mandir)/man6/; \
			$(INSTALL) -m 444 $$file $(DESTDIR)/$(mandir)/man6/; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(MAN7DIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(mandir)/man7/; \
			$(INSTALL) -m 444 $$file $(DESTDIR)/$(mandir)/man7/; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(MAN8DIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(mandir)/man8/; \
			$(INSTALL) -m 444 $$file $(DESTDIR)/$(mandir)/man8/; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(INCLUDEDIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(includedir)/; \
			$(INSTALL) -m 444 $$file $(DESTDIR)/$(includedir)/; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(PKGDATADIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(pkgdatadir)/; \
			$(INSTALL) -m 444 $$file $(DESTDIR)/$(pkgdatadir)/; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(PKGLIBDIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(pkglibdir)/; \
			$(INSTALL) -m 444 $$file $(DESTDIR)/$(pkglibdir)/; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(PKGINCLUDEDIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(pkgincludedir)/; \
			$(INSTALL) -m 444 $$file $(DESTDIR)/$(pkgincludedir)/; \
		fi; \
	done

.PHONY: echo install all clean dist-clean maintainer-clean tarball rpm

=== kexec/Makefile ===
#
# kexec (linux booting linux)
#
PURGATORY_HEX_C:= $(OBJDIR)/kexec/purgatory.c

$(PURGATORY_HEX_C): $(PURGATORY) $(BIN_TO_HEX)
	$(MKDIR) -p $(@D)
	$(BIN_TO_HEX) purgatory < $(PURGATORY) > $@

KCFLAGS:= $(CFLAGS) $(EXTRA_CFLAGS) -Ikexec/arch/$(ARCH)/include

KEXEC_C_SRCS:= kexec/kexec.c 
KEXEC_C_SRCS+= kexec/ifdown.c
KEXEC_C_SRCS+= kexec/kexec-elf.c 
KEXEC_C_SRCS+= kexec/kexec-elf-exec.c 
KEXEC_C_SRCS+= kexec/kexec-elf-core.c
KEXEC_C_SRCS+= kexec/kexec-elf-rel.c 
KEXEC_C_SRCS+= kexec/kexec-elf-boot.c 
KEXEC_C_SRCS+= kexec/kexec-iomem.c
KEXEC_C_SRCS+= kexec/crashdump.c
KEXEC_C_SRCS+= kexec/crashdump-xen.c
KEXEC_C_GENERATED_SRCS+= $(PURGATORY_HEX_C)
KEXEC_S_SRCS:= 
KEXEC_S_GENERATED_SRCS:=
include kexec/arch/$(ARCH)/Makefile

KEXEC_C_OBJS:= $(patsubst %.c, $(OBJDIR)/%.o, $(KEXEC_C_SRCS) \
	       $(KEXEC_C_GENERATED_SRCS))
KEXEC_C_DEPS:= $(patsubst %.c, $(OBJDIR)/%.d, $(KEXEC_C_SRCS))
KEXEC_C_DUMMY_DEPS:= $(patsubst %.c, $(OBJDIR)/%.d, $(KEXEC_C_GENERATED_SRCS))
KEXEC_S_OBJS:= $(patsubst %.S, $(OBJDIR)/%.o, $(KEXEC_S_SRCS) \
	       $(KEXEC_S_GENERATED_SRCS))
KEXEC_S_DEPS:= $(patsubst %.S, $(OBJDIR)/%.d, $(KEXEC_S_SRCS))
KEXEC_S_DUMMY_DEPS:= $(patsubst %.c, $(OBJDIR)/%.d, $(KEXEC_S_GENERATED_SRCS))
KEXEC_SRCS:= $(KEXEC_C_SRCS) $(KEXEC_S_SRCS)
KEXEC_OBJS:= $(KEXEC_C_OBJS) $(KEXEC_S_OBJS)
KEXEC_DEPS:= $(KEXEC_C_DEPS) $(KEXEC_S_DEPS)
KEXEC:= $(SBINDIR)/kexec
KEXEC_MANPAGE:= $(MANDIR)/man8/kexec.8

include $(KEXEC_DEPS)

$(KEXEC_C_DEPS): $(OBJDIR)/%.d: %.c
	mkdir -p $(@D)
	$(CC) $(KCFLAGS) -M $< | sed -e 's|$(patsubst %.d,%.o,$(@F))|$(patsubst %.d,%.o,$(@))|' > $@

$(KEXEC_S_DEPS): $(OBJDIR)/%.d: %.S
	mkdir -p $(@D)
	$(CC) $(KCFLAGS) -M $< | sed -e 's|$(patsubst %.d,%.o,$(@F))|$(patsubst %.d,%.o,$(@))|' > $@

# This is needed to ensure that the rule below that depend
# on each .c file having a .d file don't break
$(KEXEC_C_DUMMY_DEPS): $(OBJDIR)/%.d: %.c
	mkdir -p $(@D)
	touch $@

# This is needed to ensure that the rule below that depend
# on each .S file having a .d file don't break
$(KEXEC_S_DUMMY_DEPS): $(OBJDIR)/%.d: %.S
	mkdir -p $(@D)
	touch $@

$(KEXEC_C_OBJS): $(OBJDIR)/%.o: %.c $(OBJDIR)/%.d
	mkdir -p $(@D)
	$(CC) $(KCFLAGS) -o $@ -c $<

$(KEXEC_S_OBJS): $(OBJDIR)/%.o: %.S $(OBJDIR)/%.d
	mkdir -p $(@D)
	$(CC) $(KCFLAGS) -o $@ -c $<

$(KEXEC): $(KEXEC_OBJS) $(UTIL_LIB)
	mkdir -p $(@D)
	$(CC) $(LDFLAGS) $(EXTRA_LDFLAGS) $(KCFLAGS) -o $@ \
		$(KEXEC_OBJS) $(UTIL_LIB) $(LIBS)

$(KEXEC_MANPAGE): kexec/kexec.8
	 $(MKDIR) -p     $(MANDIR)/man8
	cp kexec/kexec.8 $(KEXEC_MANPAGE)
echo::
	@echo "KEXEC_C_SRCS $(KEXEC_C_SRCS)"
	@echo "KEXEC_C_DEPS $(KEXEC_C_DEPS)"
	@echo "KEXEC_C_OBJS $(KEXEC_C_OBJS)"
	@echo "KEXEC_S_SRCS $(KEXEC_S_SRCS)"
	@echo "KEXEC_S_DEPS $(KEXEC_S_DEPS)"
	@echo "KEXEC_S_OBJS $(KEXEC_S_OBJS)"
	@echo "KEXEC_SRCS $(KEXEC_SRCS)"
	@echo "KEXEC_DEPS $(KEXEC_DEPS)"
	@echo "KEXEC_OBJS $(KEXEC_OBJS)"

=== kexec/arch/ppc64/Makefile ===
#
# kexec ppc64 (linux booting linux)
#
KEXEC_C_SRCS+= kexec/arch/ppc64/kexec-elf-rel-ppc64.c
KEXEC_C_SRCS+= kexec/arch/ppc64/kexec-zImage-ppc64.c
KEXEC_C_SRCS+= kexec/arch/ppc64/fs2dt.c
KEXEC_C_SRCS+= kexec/arch/ppc64/kexec-elf-ppc64.c
KEXEC_C_SRCS+= kexec/arch/ppc64/kexec-ppc64.c
KEXEC_C_SRCS+= kexec/arch/ppc64/crashdump-ppc64.c

KEXEC_S_SRCS+=

## kexec-tools 20090000-2.0.0ubuntu3.1

=== kexec/arch/x86_64/Makefile ===
#
# kexec x86_64 (linux booting linux)
#
x86_64_KEXEC_SRCS =  kexec/arch/i386/kexec-elf-x86.c
x86_64_KEXEC_SRCS += kexec/arch/i386/kexec-bzImage.c
x86_64_KEXEC_SRCS += kexec/arch/i386/kexec-multiboot-x86.c
x86_64_KEXEC_SRCS += kexec/arch/i386/kexec-beoboot-x86.c
x86_64_KEXEC_SRCS += kexec/arch/i386/kexec-nbi.c
x86_64_KEXEC_SRCS += kexec/arch/i386/x86-linux-setup.c
x86_64_KEXEC_SRCS += kexec/arch/i386/kexec-x86-common.c
x86_64_KEXEC_SRCS += kexec/arch/x86_64/crashdump-x86_64.c
x86_64_KEXEC_SRCS += kexec/arch/x86_64/kexec-x86_64.c
x86_64_KEXEC_SRCS += kexec/arch/x86_64/kexec-elf-x86_64.c
x86_64_KEXEC_SRCS += kexec/arch/x86_64/kexec-elf-rel-x86_64.c

dist += kexec/arch/x86_64/Makefile $(x86_64_KEXEC_SRCS)			\
	kexec/arch/x86_64/kexec-x86_64.h kexec/arch/x86_64/crashdump-x86_64.h \
	kexec/arch/x86_64/include/arch/options.h

=== debian/changelog ===
kexec-tools (20090000-2.0.0ubuntu3.1) jaunty-proposed; urgency=low

  * debian policy forbids dpkg conffile handling and maintainer script
    configuration in the same package as this leads to inconsistant behaviour
    between apt-get install and dpkg -i installs of the same package.  Switch
    wholy to the maintainer script.  LP: #368745
  * kexec reboot has been enabled by default whereas it should have been
    opt-in, it is therefore appropriate to force this off for upgrades from
    older versions.  LP: #251242
  * kexec based reboot triggers a number of semanatic changes which
    are visible to the user, it should be opt-in by default.  Adjust
    kexec.default to disable kexec by default.  LP: #251242

 -- Andy Whitcroft <apw@canonical.com>  Mon, 27 Apr 2009 10:32:46 +0100

=== debian/control ===
Source: kexec-tools
Section: admin
Priority: optional
Maintainer: Khalid Aziz <khalid@debian.org>
Build-Depends: debhelper (>= 4.0.0), dpatch, gnu-efi (>=3.0a-4)[ia64], libz-dev[ia64], po-debconf, automake1.9
Standards-Version: 3.7.3

Package: kexec-tools
Architecture: i386 amd64 ppc64 powerpc ia64 s390 arm armel
Depends: ${shlibs:Depends}, ${misc:Depends}, debconf, initramfs-tools
Description: kexec tool for kexec reboots
 This tool is used to load a kernel in memory and reboot into the kernel
 loaded in memory using the kexec system call.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpatch/dpatch.make


CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

configure: patch configure-stamp
configure-stamp: 
	dh_testdir
	# Add here commands to configure the package.
	if [ ! -f ./configure ] ; then aclocal -I config; autoheader; autoconf; fi; \
	./configure --prefix=/usr --sbindir=/sbin --mandir=/usr/share/man --datadir=/usr/share

	touch configure-stamp


build: patch build-stamp

build-stamp: configure-stamp 
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE)

	touch build-stamp

clean: tidy unpatch

tidy: patch configure-stamp 
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp 
	rm -fr tmp-source

	# Add here commands to clean up after the build process.
	$(MAKE) dist-clean

	dh_clean 
	debconf-updatepo

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs

	# Add here commands to install the package into debian/tmp.
	$(MAKE) install DESTDIR=$(CURDIR)/debian/kexec-tools
	install -D -m755 debian/kdump.initramfs \
		debian/kexec-tools/usr/share/initramfs-tools/scripts/init-bottom/0_kdump
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	[ ! -f $(CURDIR)/debian/kexec-tools/usr/lib/kexec-tools-testing/kexec_test.static ] || strip $(CURDIR)/debian/kexec-tools/usr/lib/kexec-tools-testing/kexec_test.static
endif


# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_installdebconf
	dh_installinit --no-start -r --name=kexec -- start 85 6 .
	dh_installinit --no-start -r --name=kexec-load -- stop 18 6 .
	dh_installinit --no-start -r --name=kdump -- start 00 2 .
	dh_installexamples
	dh_install
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

=== debian/watch ===
version=3
http://www.kernel.org/pub/linux/kernel/people/horms/kexec-tools/kexec-tools-testing-(.*)\.tar\.gz

## kexec-tools 20090000-2.0.0ubuntu12

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: kexec-tools
 Section: admin
 Priority: optional
-Maintainer: Khalid Aziz <khalid@debian.org>
+Maintainer: Ubuntu Core Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Khalid Aziz <khalid@debian.org>
 Build-Depends: debhelper (>= 4.0.0), dpatch, gnu-efi (>=3.0a-4)[ia64], libz-dev[ia64], po-debconf, automake1.9
 Standards-Version: 3.7.3

## kexec-tools 20090000-2.0.0ubuntu12drbl

=== debian/changelog ===
kexec-tools (20090000-2.0.0ubuntu12drbl) karmic; urgency=low

  * A workaround to avoid bug #401405 was added.

 -- Steven Shiau <steven@nchc.org.tw>  Fri, 09 Oct 2009 15:29:00 +0800
